Subject: Re: A Basic Git Question About File Tracking

From: Jon Forrest <[email-masked]>
Date: Sat, 08 Oct 2011 17:08:44 -0700

On 10/3/2011 6:22 PM, Jonathan Nieder wrote:

[I'm just getting back to this question. I had accidentally
sent this follow up directly to Jonathan but I want to
continue this on the email list.]

> Yes, "x" is tracked.  Moreover, "x" is in the index.  You can
> list files in the index with the "git ls-files -s" command.

This spoils my understanding of what the index
is. I had been thinking that after you add files
to the index, and then commit, the index is then
empty. In other words, whatever's in the index
gets committed, and then the index is cleaned.

On the other hand, if the definition of a tracked
file is a file that's in the index, then this definitely
clears up my understanding of tracked files.

If every file that's 'git add'ed stays in the
index, how does git know which files to commit?

I can't prove it but I suspect that many git beginners
also are confused by this.

Thanks for your replies.

Jon Forrest